#ifndef __SLHTTP_H__
#define __SLHTTP_H__


/* Error code */
enum {
	SLHTTP_E_SUCCESS = 0,
	SLHTTP_E_INVALID_SCHEME,
	SLHTTP_E_INVALID_URI,
	SLHTTP_E_NO_MEMORY,
	SLHTTP_E_GETHOSTBYNAME,
	SLHTTP_E_SOCKET,
	SLHTTP_E_CONNECT,
	SLHTTP_E_INVALID_HTTP_RESPONSE
};




/**
 * Do `GET' to `http_uri' and store its response.
 * Return SLHTTP_E_SUCCESS (= 0) for success or other value for failure.
 *
 * `*status_line', `*headers' and `*message_body' will be stored
 * a string which is allocated by malloc(),
 * so you MUST free() if it is no longer used.
 *
 * `*status_line' doesn't contain trailing `\r\n'.
 * `*headers' is separated by `\r\n'.
 * For example, "Date: ...\r\nServer: ...\r\nContent-Type: ...".
 */

int slhttp_get( const char* http_uri, const char* user_agent,
                int* status_code, char** status_line,
                char** headers,
                char** message_body );




#endif
